// Klasse Artifact

import java.lang.*;
import java.util.Vector;
import java.sql.*;

public class Artifact {

        // Variablen id (Inventarnummer = Schluessel), name (Name des Artefakts), Vector attributes (Attribute)

        private int id;
        private String name;
        private Vector attributes;

        // Konstruktoren: ObjAttribute() sinnlos, weil unklar, welche id festgelegt werden soll (id = 0 ?)

        public Artifact(int id) {
                this.id = id;
                name = new String();
                attributes = new Vector();
        }

        public Artifact(int id, String name) {
                this.id = id;
                this.name = new String(name);
                attributes = new Vector();
        }

        // Methoden

        // Instanz aus der Datenbank bilden

        static public Artifact getInstance(int id, Connection con) {

                Artifact art = null;

                try {
                        Statement stmt = con.createStatement();
                        ResultSet rs;
                        String query;

                        // Send the query and bind to the result set
                        query ="select * from ARTIFACTS where ARTIFACTS.ID=" + id ;
                        rs = stmt.executeQuery(query);
	        while (rs.next()) {
	                art = new Artifact(rs.getInt("ID"), rs.getString("NAME"));
	        }

                        query ="select ID,NAME,VALUE,VISIBLE from ARTATTRIBUTES where ARTATTRIBUTES.ART_ID=" + id + " order by ID";
                        rs = stmt.executeQuery(query);
	        while (rs.next()) {
	                art.addAttribute(new ArtAttribute(rs.getString("NAME"), rs.getString("VALUE"),rs.getBoolean("VISIBLE")));
	        }

	        // Close resources
	        stmt.close();
                }

	catch(SQLException ex) {
                        System.err.println("==> SQLException: ");
	        while (ex != null) {
		System.out.println("Message:   " + ex.getMessage ());
		System.out.println("SQLState:  " + ex.getSQLState ());
		System.out.println("ErrorCode: " + ex.getErrorCode ());
		ex = ex.getNextException();
		System.out.println("");
	        }
                }

                return art;
        }

        // Methoden, um Werte zu setzen

        public void setId(int id) {
                this.id = id;
        }

        public void setName(String name) {
                this.name = new String(name);
        }

        // Methoden, um Werte auszulesen

        public int getId() {
                return id;
        }

        public String getName() {
               return name;
        }

        // Methoden, um Attribute hinzuzufuegen, auszulesen, zu loeschen

        public void addAttribute(ArtAttribute attribute) {
                attributes.addElement(attribute);
        }

        public void deleteAttribute(int id) {
                attributes.removeElementAt(id);
        }

        public void deleteAllAttributes() {
                attributes = new Vector();
        }

        public ArtAttribute getAttribute(int index) {
                if (index < attributes.size())
                        return (ArtAttribute)attributes.elementAt(index);
                else
                        return null;
        }

        // Schreibe in die Datenbank

        public void saveToDatabase(Connection con) {

                try {
                        Statement stmt = con.createStatement();
                        String query;

                        // Delete old Artifact and Attributes from Database
                        query = "delete from ARTIFACTS where ARTIFACTS.ID=" + this.getId();
                        stmt.executeUpdate(query);
                        query = "delete from ARTATTRIBUTES where ART_ID=" + this.getId();
                        stmt.executeUpdate(query);

                        // save new Artifact to Database
                        query = "insert into ARTIFACTS values (" + this.getId() + ",'" + this.getName() + "')";
                        stmt.executeUpdate(query);

                        // save new attributes of artifact to database
                        int i = 0;
                        ArtAttribute attrib = this.getAttribute(i);
                        while (attrib != null) {
                                query = "insert into ARTATTRIBUTES values (" + i + ",'" + attrib.getName() + "','" + attrib.getValue() + "','" + attrib.getVisible() + "'," + this.getId()+")";
                                System.out.println(attrib.getName() + "  " + i);
                                stmt.executeUpdate(query);
                                i++;
                                attrib = this.getAttribute(i);
                        }

	        // Close resources
	        stmt.close();
                }

	catch(SQLException ex) {
                        System.err.println("==> SQLException: ");
	        while (ex != null) {
		System.out.println("Message:   " + ex.getMessage ());
		System.out.println("SQLState:  " + ex.getSQLState ());
		System.out.println("ErrorCode: " + ex.getErrorCode ());
		ex = ex.getNextException();
		System.out.println("");
	        }
                }

        }

}